#!/usr/bin/perl

$dir = './man';
$docdir = './doc';

&main();
exit(0);

sub main
{
	&read_dirs();
}

sub read_dirs
{
	my($foo, $fname, $fname_w);
	opendir(DIR, "$dir") || (die "Couldn't open dir $dir");
	while($fname = readdir(DIR))
	{
		(-d "$dir/$fname") || next;
		($fname =~ /man(\d)$/) || next;
		push(@nums, $1);
	}
	closedir(DIR);
	foreach $foo (@nums)
	{
		opendir(DIR, "$dir/man$foo") ||
			(die "Couldn't open dir $dir/man$foo");
		while($fname = readdir(DIR))
		{
			($fname =~ /$foo$/) || next;
			$fname_w = "$dir/man$foo/$fname";
			open(PIPE, "nroff -man $fname_w|") || next;
			open(FILE, ">$docdir/$fname.txt");
			while(<PIPE>)
			{
				s/.()//g;
				print FILE;
			}
			close(PIPE);
			close(FILE);
		}
	}
}
