#!/usr/bin/perl
#
# Good lord, don't use this thing.   -spb
#

use Tk;

$max_x = 2500;
$max_y = 2500;
$max_x = 750;
$max_y = 750;
$wmx = 750;
$wmy = 750;
$mradius = int(($max_x + $max_y) / 10);
$cradius = int(($max_x + $max_y) / 10);
#$mradius = int(($wmx + $wmy) / 10);
#$cradius = int(($wmx + $wmy) / 10);
$xm = int($max_x / 2);
$ym = int($max_y / 2);
$pi = atan2(1,1) * 4;

$font =  '-*-Helvetica-Medium-R-Normal--*-80-*-*-*-*-*-*';

require("getopts.pl");
&read_config("/etc/shoki.conf");
require("$INSTALL_PREFIX/$ETCDIR/collector.conf");

&Getopts("E:S:");
$parser = "$INSTALL_PREFIX/$BINDIR/parser";

&main();
exit(0);

sub main
{
	print("Reading dirs...\n");
	&read_dirs();
	print("done.\n");
	print("Finding cliques...\n");
	&find_cliques();
	print("done.\n");
	print("Finding mappings...\n");
	&find_mappings();
	print("done.\n");
	&make_window();
	print("Doing circle\n");
	&do_circle();
	&do_lines();
	print("Main loop\n");
	MainLoop;
}

sub make_window
{
	my($xs, $ys);

	$main = new MainWindow(-title=>"Foo");
	$bottom = $main->Frame;
	$canv = $bottom->Canvas(-width=>$wmx, -height=>$wmy, -relief=>'sunken');
	$xs = $bottom->Scrollbar(-orient=>'horiz',
		-command=>['xview', $canv]);
	$ys = $bottom->Scrollbar(-command=>['yview', $canv]);
	$canv->configure(-xscrollcommand=>['set', $xs]);
	$canv->configure(-yscrollcommand=>['set', $ys]);
	$xs->pack(-side=>'bottom', -fill=>'x');
	$ys->pack(-side=>'right', -fill=>'y');
	$canv->configure(-scrollregion=>[0, 0, $max_x, $max_y]);
	$canv->pack(-side=>'bottom', -expand=>'yes', -fill=>'both');
	$bottom->pack;
}

sub read_dirs
{
	my($foo, $bar, $fname, $fname_w, @baz);
	foreach $foo (@sensors)
	{
		$bar = "$INSTALL_PREFIX/central/log/$foo";
		opendir(DIR, $bar) || next;
		while($fname = readdir(DIR))
		{
			($fname =~ /$foo-sensor_dump\.(\d+)-(\d+)\.gz/) ||
				next;
			($1 > $opt_E) && next;
			($2 < $opt_S) && next;
			$fname_w = "$bar/$fname";
			#open(PIPE, "zcat $fname_w | /usr/local/bin//tcpdump_fixed -r - -n -l -e -q -tt tcp or udp or icmp |") || next;
			open(PIPE, "zcat $fname_w | /usr/local/bin//tcpdump_fixed -r - -n -l -e -q -tt tcp and port 80 |") || next;
			while(<PIPE>)
			{
				chomp;
				@foo = split('\s+', $_);
				($foo[1] =~ /ff:ff:ff:ff:ff:ff/i) && next;
				($foo[2] =~ /ff:ff:ff:ff:ff:ff/i) && next;
				($foo[4] =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)\.(\d+)/) && ($foo[4] =~ s/\.(\d+)$//);
				($foo[6] =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)\.(\d+)/) && ($foo[6] =~ s/\.(\d+)$//);
				($foo[4] =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)\.(\d+):/) && ($foo[4] =~ s/\.(\d+):$//);
				($foo[6] =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)\.(\d+):/) && ($foo[6] =~ s/\.(\d+):$//);
				$foo[4] =~ s/:$//g;
				$foo[6] =~ s/:$//g;
				($foo[4] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)
					|| next;
				($foo[6] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)
					|| next;
				($hard{$foo[1]} =~ /$foo[4]/) || ($hard{$foo[1]} .= "$foo[4]#");
				($hard{$foo[2]} =~ /$foo[6]/) || ($hard{$foo[2]} .= "$foo[6]#");
				$edge_e{"$foo[1]#$foo[2]"}++;
				($edge_i{"$foo[4]#$foo[6]"} =~
					/$foo[1]#$foo[2]/) ||
					($edge_i{"$foo[4]#$foo[6]"} .=
					"$foo[1]#$foo[2]x");
				($vertex_e{$foo[1]} =~ /$foo[2]/) || ($vertex_e{$foo[1]} .= "$foo[2]#");
				($vertex_i{$foo[4]} =~ /$foo[6]/) || ($vertex_i{$foo[4]} .= "$foo[6]#");
				($dsts{$foo[6]} =~ /$foo[2]/) || ($dsts{$foo[6]} .= "$foo[2]#");
				($srcs{$foo[4]} =~ /$foo[1]/) || ($srcs{$foo[4]} .= "$foo[1]#");
			}
			close(PIPE);
		}
		closedir(DIR);
	}
}

# They're not really cliques, but what the hell -spb
sub find_cliques
{
	my($foo, $bar, $src_e, $dst_e, $a, $b, @baz);
	foreach $foo (keys %edge_e)
	{
		($src_e, $dst_e) = split('#', $foo);
		if($clique{$src_e})
		{
			if($clique{$dst_e})
			{
				if($clique{$dst_e} != $clique{$src_e})
				{
					if($clique{$src_e} > $clique{$dst_e})
					{
						$a = $dst_e;
						$b = $src_e;
					}
					else
					{
						$b = $dst_e;
						$a = $src_e;
					}
					print("Folding clique $clique{$b} into $clique{$a}\n");
					foreach $bar (keys %clique)
					{
						($clique{$bar} == $clique{$b}) && ($clique{$bar} = $clique{$a});
					}
					$clique{$b} = $clique{$a};
				}
			}
			else
			{
				$clique{$dst_e} = $clique{$src_e};
			}
		}
		else
		{
			if($clique{$dst_e})
			{
				$clique{$src_e} = $clique{$dst_e};
			}
			else
			{
				$cliques++;
				$clique{$src_e} = $cliques;
				$clique{$dst_e} = $cliques;
			}
		}
	}
	$cliques++;
	$clique{"O"} = $cliques;
	print("O clique:  $cliques\n");
	$nc{$cliques}++;
	$cliques = 1;
	foreach $foo (keys %edge_e)
	{
		($src_e, $dst_e) = split('#', $foo);
		($clique{$src_e} != $clique{$dst_e}) && (print "Clique mismatch\n");
		$nc{$clique{$src_e}} || ($nc{$clique{$src_e}}++, $cliques++);
	}
	$bar = 0;
	foreach $foo (keys %vertex_e)
	{
		@baz = split('#', $vertext_e{$foo});
		($#baz > $bar) && (($bar = $#baz), ($gate{$clique{$foo}} = $foo));
	}
	print "Number of cliques:  $cliques\n";
}

sub read_config
{
	my($fname) = @_;
	open(FILE, "<$fname") ||
	(die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}

sub find_mappings
{
	my($foo, $bar, @baz, @path);
	my($src_i, $dst_i, $src_e, $dst_e, $src_e2, $dst_e2);
	my($x1, $y1, $x2, $y2, $x3, $y3, $x4, $y4);
	foreach $foo (keys %edge_i)
	{
		($src_i, $dst_i) = split('#', $foo);
		@baz = split('x', $edge_i{$foo});
		if($#baz != 0)
		{
			$src_e = "O";
			$dst_e = "O";
		}
		else
		{
			($src_e, $dst_e) = split('#', $baz[0]);
		}
		@baz = split('#', $srcs{$src_i});
		if($#baz != 0)
		{
			$src_e2 = "O";
		}
		else
		{
			$src_e2 = $baz[0];
		}
		@baz = split('#', $dsts{$dst_i});
		if($#baz != 0)
		{
			$dst_e2 = "O";
		}
		else
		{
			$dst_e2 = $baz[0];
		}
		#$link{$src_i} = $src_e2;
		#$link{$dst_i} = $dst_e2;
		$links{$src_e2} .= "$src_i#";
		$links{$dst_e2} .= "$dst_i#";
		#($ix1, $iy1) = split(',', $node{$src_i});
		#($ix2, $iy2) = split(',', $node{$dst_i});
		#($x1, $y1) = split(',', $node{$src_e2});
		#($x2, $y2) = split(',', $node{$src_e});
		#($x3, $y3) = split(',', $node{$dst_e});
		#($x4, $y4) = split(',', $node{$dst_e2});
		@path = ();
		#push(@path, $ix1, $iy1, $x1, $y1);
		#($src_e2 ne $src_e) && push(@path, $x2, $y2);
		#($dst_e2 ne $dst_e) && push(@path, $x3, $y3);
		#push(@path, $x4, $y4, $ix2, $iy2);
		#$canv->createLine(@path, -width=>1, -fill=>'white', -arrow=>'last');
		push(@path, $src_i, $src_e2);
		($src_e2 ne $src_e) && push(@path, $src_e);
		($dst_e2 ne $dst_e) && push(@path, $dst_e);
		push(@path, $dst_e2, $dst_i);
		$paths{$foo} = join('#', @path);
	}
}

sub do_lines
{
	my($x, $y, @path, @points, $foo, $bar);

	foreach $foo (keys %paths)
	{
		#print("Doing path for $foo:\n\t$paths{$foo}\n");
		@path = split('#', $paths{$foo});
		@points = ();
		while($bar = shift(@path))
		{
			($x, $y) = split(',', $node{$bar});
			push(@points, $x, $y);
		}
		$canv->createLine(@points, -width=>1, -fill=>'white', -arrow=>'last');
	}
}

sub do_circle
{
	my($space, $rradius, $i, $x, $y, $a, $foo, @bar);
	$canv->createRectangle(0, 0, $max_x, $max_y, -fill=>'black', -width=>0, -outline=>undef);
	$space = &deg2rad(360 / $cliques);
	($space == 0) && (die "Bad space\n");
	$rradius = $mradius;
	while(($space * ($rradius / $mradius)) < .1)
	{
		$rradius++;
		#print("\trradius:  $rradius\n");
	}
	$canv->create(oval=>($xm - $rradius), ($ym - $rradius), ($xm + $rradius), ($ym + $rradius), -outline=>'green', -width=>10);
	@bar = (keys %nc);
	foreach $foo (@bar)
	{
		$x = $xm + ($rradius * cos($a));
		$y = $ym + ($rradius * sin($a));
		&do_clique($x, $y, $a, $foo);
		$a += $space;
	}
}

sub do_clique
{
	my($x, $y, $a, $c) = @_;
	my($rradius, @nc, $foo, $cx, $cy, $aa, $xx, $yy);
	
	print("Doing clique $c\n");
	$aa = $a - ($pi / 2);
	@nc = ();
	foreach $foo (%clique)
	{
		($clique{$foo} == $c) || next;
		($gate{$c} eq $foo) && (unshift(@nc, $foo), 1) ||
			push(@nc, $foo);
	}
	($#nc < 0) && ((print "Empty clique $c\n"), return);
	$space = &deg2rad(360 / (($#nc + 1) * 2));
	($space == 0) && (die "Bad space\n");
	$rradius = ($cradius / 5);
	while(((sin($space)/cos($space)) * $rradius) < ($max_y / 20))
	{
		$rradius++;
		($rradius > $cradius) && last;
		#print("\trradius:  $rradius ", abs((sin($space)/cos($space))*$rradius), "\n");
	}
	($#nc == 1) && ($rradius = $cradius / 5);
	($#nc == 0) && ($rradius = 1);
	$xx = $x + ($rradius * cos($a));
	$yy = $y + ($rradius * sin($a));
	$canv->create(oval=>($xx - $rradius), ($yy - $rradius), ($xx + $rradius), ($yy + $rradius), -outline=>'yellow', -width=>5);
	while($foo = shift(@nc))
	{
		print("\tadding $foo\n");
		$cx = $xx + ($rradius * cos($aa));
		$cy = $yy + ($rradius * sin($aa));
		#$canv->createText($cx, $cy, -text=>"$foo", -font=>$font, -fill=>'white');
		$node{$foo} = join(',', $cx, $cy);
		&do_subclique($foo, $aa);
		$aa += $space;
	}
}

sub do_subclique
{
	my($e, $a) = @_;
	my($space, $rradius, $x, $y, $xx, $yy, $cx, $cy, $aa);

	$aa = $a - ($pi / 2);
	($x, $y) = split(',', $node{$e});
	@bar = split('#', $links{$e});
	($#bar < 0) && ((print "Empty subclique for $e\n"), return);
	$space = &deg2rad(360 / (($#bar + 1) * 2));
	($space == 0) && (die "Bad space\n");
	$rradius = ($cradius / 5);
	while(((sin($space)/cos($space)) * $rradius) < ($max_y / 20))
	{
		$rradius++;
		($rradius > $cradius) && last;
	}
	($#bar == 1) && ($rradius = $cradius / 5);
	($#bar == 0) && ($rradius = 1);
	$xx = $x + ($rradius * cos($a));
	$yy = $y + ($rradius * sin($a));
	$canv->create(oval=>($xx - $rradius), ($yy - $rradius), ($xx + $rradius), ($yy + $rradius), -outline=>'red');
	while($foo = pop(@bar))
	{
		print("\t\tadding $foo\n");
		$cx = $xx + ($rradius * cos($aa));
		$cy = $yy + ($rradius * sin($aa));
		#$canv->createText($cx, $cy, -text=>"$foo", -font=>$font, -fill=>'white');
		$node{$foo} = join(',', $cx, $cy);
		$aa += $space;
	}
}

sub deg2rad
{
	my($deg) = @_;
	return($deg*$pi/180);
}
